// -*- C++ -*-
//
// This file was generated by CLI, a command line interface
// compiler for C++.
//

#ifndef MOD_OPTIONS_HXX
#define MOD_OPTIONS_HXX

// Begin prologue.
//
//
// End prologue.

#include <deque>
#include <map>
#include <vector>
#include <iosfwd>
#include <string>
#include <cstddef>
#include <exception>

#ifndef CLI_POTENTIALLY_UNUSED
#  if defined(_MSC_VER) || defined(__xlC__)
#    define CLI_POTENTIALLY_UNUSED(x) (void*)&x
#  else
#    define CLI_POTENTIALLY_UNUSED(x) (void)x
#  endif
#endif

namespace brep
{
  namespace cli
  {
    class unknown_mode
    {
      public:
      enum value
      {
        skip,
        stop,
        fail
      };

      unknown_mode (value);

      operator value () const 
      {
        return v_;
      }

      private:
      value v_;
    };

    // Exceptions.
    //

    class exception: public std::exception
    {
      public:
      virtual void
      print (::std::ostream&) const = 0;
    };

    ::std::ostream&
    operator<< (::std::ostream&, const exception&);

    class unknown_option: public exception
    {
      public:
      virtual
      ~unknown_option () throw ();

      unknown_option (const std::string& option);

      const std::string&
      option () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string option_;
    };

    class unknown_argument: public exception
    {
      public:
      virtual
      ~unknown_argument () throw ();

      unknown_argument (const std::string& argument);

      const std::string&
      argument () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string argument_;
    };

    class missing_value: public exception
    {
      public:
      virtual
      ~missing_value () throw ();

      missing_value (const std::string& option);

      const std::string&
      option () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string option_;
    };

    class invalid_value: public exception
    {
      public:
      virtual
      ~invalid_value () throw ();

      invalid_value (const std::string& option,
                     const std::string& value);

      const std::string&
      option () const;

      const std::string&
      value () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string option_;
      std::string value_;
    };

    class eos_reached: public exception
    {
      public:
      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();
    };

    class file_io_failure: public exception
    {
      public:
      virtual
      ~file_io_failure () throw ();

      file_io_failure (const std::string& file);

      const std::string&
      file () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string file_;
    };

    class unmatched_quote: public exception
    {
      public:
      virtual
      ~unmatched_quote () throw ();

      unmatched_quote (const std::string& argument);

      const std::string&
      argument () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string argument_;
    };

    // Command line argument scanner interface.
    //
    // The values returned by next() are guaranteed to be valid
    // for the two previous arguments up until a call to a third
    // peek() or next().
    //
    class scanner
    {
      public:
      virtual
      ~scanner ();

      virtual bool
      more () = 0;

      virtual const char*
      peek () = 0;

      virtual const char*
      next () = 0;

      virtual void
      skip () = 0;
    };

    class argv_scanner: public scanner
    {
      public:
      argv_scanner (int& argc, char** argv, bool erase = false);
      argv_scanner (int start, int& argc, char** argv, bool erase = false);

      int
      end () const;

      virtual bool
      more ();

      virtual const char*
      peek ();

      virtual const char*
      next ();

      virtual void
      skip ();

      private:
      int i_;
      int& argc_;
      char** argv_;
      bool erase_;
    };

    class argv_file_scanner: public argv_scanner
    {
      public:
      argv_file_scanner (int& argc,
                         char** argv,
                         const std::string& option,
                         bool erase = false);

      argv_file_scanner (int start,
                         int& argc,
                         char** argv,
                         const std::string& option,
                         bool erase = false);

      struct option_info
      {
        // If search_func is not NULL, it is called, with the arg
        // value as the second argument, to locate the options file.
        // If it returns an empty string, then the file is ignored.
        //
        const char* option;
        std::string (*search_func) (const char*, void* arg);
        void* arg;
      };

      argv_file_scanner (int& argc,
                          char** argv,
                          const option_info* options,
                          std::size_t options_count,
                          bool erase = false);

      argv_file_scanner (int start,
                         int& argc,
                         char** argv,
                         const option_info* options,
                         std::size_t options_count,
                         bool erase = false);

      virtual bool
      more ();

      virtual const char*
      peek ();

      virtual const char*
      next ();

      virtual void
      skip ();

      private:
      const option_info*
      find (const char*) const;

      void
      load (const std::string& file);

      typedef argv_scanner base;

      const std::string option_;
      option_info option_info_;
      const option_info* options_;
      std::size_t options_count_;

      std::deque<std::string> args_;

      // Circular buffer of two arguments.
      //
      std::string hold_[2];
      std::size_t i_;

      bool skip_;
    };

    typedef std::vector<std::string> option_names;

    class option
    {
      public:

      const std::string&
      name () const;

      const option_names&
      aliases () const;

      bool
      flag () const;

      const std::string&
      default_value () const;

      public:option ();
      option (const std::string& name,
              const option_names& aliases,
              bool flag,
              const std::string& default_value);

      private:
      std::string name_;
      option_names aliases_;
      bool flag_;
      std::string default_value_;
    };

    class options: public std::vector<option>
    {
      public:
      typedef std::vector<option> container_type;

      container_type::const_iterator
      find (const std::string& name) const;

      void
      push_back (const option&);
      private:
      typedef std::map<std::string, container_type::size_type> map_type;
      map_type map_;
    };

    template <typename X>
    struct parser;
  }
}

#include <web/xhtml-fragment.hxx>

#include <libbrep/types.hxx>

#include <mod/options-types.hxx>

namespace brep
{
  namespace options
  {
    class module
    {
      public:
      module ();

      module (int& argc,
              char** argv,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      module (int start,
              int& argc,
              char** argv,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      module (int& argc,
              char** argv,
              int& end,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      module (int start,
              int& argc,
              char** argv,
              int& end,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      module (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const string&
      email () const;

      string&
      email ();

      void
      email (const string&);

      bool
      email_specified () const;

      void
      email_specified (bool);

      const string&
      host () const;

      string&
      host ();

      void
      host (const string&);

      bool
      host_specified () const;

      void
      host_specified (bool);

      const dir_path&
      root () const;

      dir_path&
      root ();

      void
      root (const dir_path&);

      bool
      root_specified () const;

      void
      root_specified (bool);

      const uint16_t&
      verbosity () const;

      uint16_t&
      verbosity ();

      void
      verbosity (const uint16_t&);

      bool
      verbosity_specified () const;

      void
      verbosity_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_module_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      string email_;
      bool email_specified_;
      string host_;
      bool host_specified_;
      dir_path root_;
      bool root_specified_;
      uint16_t verbosity_;
      bool verbosity_specified_;
    };

    class openssl_options
    {
      public:
      openssl_options ();

      openssl_options (int& argc,
                       char** argv,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      openssl_options (int start,
                       int& argc,
                       char** argv,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      openssl_options (int& argc,
                       char** argv,
                       int& end,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      openssl_options (int start,
                       int& argc,
                       char** argv,
                       int& end,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      openssl_options (::brep::cli::scanner&,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const path&
      openssl () const;

      path&
      openssl ();

      void
      openssl (const path&);

      bool
      openssl_specified () const;

      void
      openssl_specified (bool);

      const strings&
      openssl_option () const;

      strings&
      openssl_option ();

      void
      openssl_option (const strings&);

      bool
      openssl_option_specified () const;

      void
      openssl_option_specified (bool);

      const strings&
      openssl_envvar () const;

      strings&
      openssl_envvar ();

      void
      openssl_envvar (const strings&);

      bool
      openssl_envvar_specified () const;

      void
      openssl_envvar_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_openssl_options_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      path openssl_;
      bool openssl_specified_;
      strings openssl_option_;
      bool openssl_option_specified_;
      strings openssl_envvar_;
      bool openssl_envvar_specified_;
    };

    class package_db
    {
      public:
      package_db ();

      package_db (int& argc,
                  char** argv,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_db (int start,
                  int& argc,
                  char** argv,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_db (int& argc,
                  char** argv,
                  int& end,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_db (int start,
                  int& argc,
                  char** argv,
                  int& end,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_db (::brep::cli::scanner&,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const string&
      package_db_user () const;

      string&
      package_db_user ();

      void
      package_db_user (const string&);

      bool
      package_db_user_specified () const;

      void
      package_db_user_specified (bool);

      const string&
      package_db_role () const;

      string&
      package_db_role ();

      void
      package_db_role (const string&);

      bool
      package_db_role_specified () const;

      void
      package_db_role_specified (bool);

      const string&
      package_db_password () const;

      string&
      package_db_password ();

      void
      package_db_password (const string&);

      bool
      package_db_password_specified () const;

      void
      package_db_password_specified (bool);

      const string&
      package_db_name () const;

      string&
      package_db_name ();

      void
      package_db_name (const string&);

      bool
      package_db_name_specified () const;

      void
      package_db_name_specified (bool);

      const string&
      package_db_host () const;

      string&
      package_db_host ();

      void
      package_db_host (const string&);

      bool
      package_db_host_specified () const;

      void
      package_db_host_specified (bool);

      const uint16_t&
      package_db_port () const;

      uint16_t&
      package_db_port ();

      void
      package_db_port (const uint16_t&);

      bool
      package_db_port_specified () const;

      void
      package_db_port_specified (bool);

      const size_t&
      package_db_max_connections () const;

      size_t&
      package_db_max_connections ();

      void
      package_db_max_connections (const size_t&);

      bool
      package_db_max_connections_specified () const;

      void
      package_db_max_connections_specified (bool);

      const size_t&
      package_db_retry () const;

      size_t&
      package_db_retry ();

      void
      package_db_retry (const size_t&);

      bool
      package_db_retry_specified () const;

      void
      package_db_retry_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_package_db_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      string package_db_user_;
      bool package_db_user_specified_;
      string package_db_role_;
      bool package_db_role_specified_;
      string package_db_password_;
      bool package_db_password_specified_;
      string package_db_name_;
      bool package_db_name_specified_;
      string package_db_host_;
      bool package_db_host_specified_;
      uint16_t package_db_port_;
      bool package_db_port_specified_;
      size_t package_db_max_connections_;
      bool package_db_max_connections_specified_;
      size_t package_db_retry_;
      bool package_db_retry_specified_;
    };

    class build: public ::brep::options::openssl_options
    {
      public:
      build ();

      build (int& argc,
             char** argv,
             bool erase = false,
             ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
             ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build (int start,
             int& argc,
             char** argv,
             bool erase = false,
             ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
             ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build (int& argc,
             char** argv,
             int& end,
             bool erase = false,
             ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
             ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build (int start,
             int& argc,
             char** argv,
             int& end,
             bool erase = false,
             ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
             ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build (::brep::cli::scanner&,
             ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
             ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const path&
      build_config () const;

      path&
      build_config ();

      void
      build_config (const path&);

      bool
      build_config_specified () const;

      void
      build_config_specified (bool);

      const dir_path&
      build_bot_agent_keys () const;

      dir_path&
      build_bot_agent_keys ();

      void
      build_bot_agent_keys (const dir_path&);

      bool
      build_bot_agent_keys_specified () const;

      void
      build_bot_agent_keys_specified (bool);

      const size_t&
      build_forced_rebuild_timeout () const;

      size_t&
      build_forced_rebuild_timeout ();

      void
      build_forced_rebuild_timeout (const size_t&);

      bool
      build_forced_rebuild_timeout_specified () const;

      void
      build_forced_rebuild_timeout_specified (bool);

      const size_t&
      build_normal_rebuild_timeout () const;

      size_t&
      build_normal_rebuild_timeout ();

      void
      build_normal_rebuild_timeout (const size_t&);

      bool
      build_normal_rebuild_timeout_specified () const;

      void
      build_normal_rebuild_timeout_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_build_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      path build_config_;
      bool build_config_specified_;
      dir_path build_bot_agent_keys_;
      bool build_bot_agent_keys_specified_;
      size_t build_forced_rebuild_timeout_;
      bool build_forced_rebuild_timeout_specified_;
      size_t build_normal_rebuild_timeout_;
      bool build_normal_rebuild_timeout_specified_;
    };

    class build_db
    {
      public:
      build_db ();

      build_db (int& argc,
                char** argv,
                bool erase = false,
                ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_db (int start,
                int& argc,
                char** argv,
                bool erase = false,
                ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_db (int& argc,
                char** argv,
                int& end,
                bool erase = false,
                ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_db (int start,
                int& argc,
                char** argv,
                int& end,
                bool erase = false,
                ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_db (::brep::cli::scanner&,
                ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const string&
      build_db_user () const;

      string&
      build_db_user ();

      void
      build_db_user (const string&);

      bool
      build_db_user_specified () const;

      void
      build_db_user_specified (bool);

      const string&
      build_db_role () const;

      string&
      build_db_role ();

      void
      build_db_role (const string&);

      bool
      build_db_role_specified () const;

      void
      build_db_role_specified (bool);

      const string&
      build_db_password () const;

      string&
      build_db_password ();

      void
      build_db_password (const string&);

      bool
      build_db_password_specified () const;

      void
      build_db_password_specified (bool);

      const string&
      build_db_name () const;

      string&
      build_db_name ();

      void
      build_db_name (const string&);

      bool
      build_db_name_specified () const;

      void
      build_db_name_specified (bool);

      const string&
      build_db_host () const;

      string&
      build_db_host ();

      void
      build_db_host (const string&);

      bool
      build_db_host_specified () const;

      void
      build_db_host_specified (bool);

      const uint16_t&
      build_db_port () const;

      uint16_t&
      build_db_port ();

      void
      build_db_port (const uint16_t&);

      bool
      build_db_port_specified () const;

      void
      build_db_port_specified (bool);

      const size_t&
      build_db_max_connections () const;

      size_t&
      build_db_max_connections ();

      void
      build_db_max_connections (const size_t&);

      bool
      build_db_max_connections_specified () const;

      void
      build_db_max_connections_specified (bool);

      const size_t&
      build_db_retry () const;

      size_t&
      build_db_retry ();

      void
      build_db_retry (const size_t&);

      bool
      build_db_retry_specified () const;

      void
      build_db_retry_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_build_db_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      string build_db_user_;
      bool build_db_user_specified_;
      string build_db_role_;
      bool build_db_role_specified_;
      string build_db_password_;
      bool build_db_password_specified_;
      string build_db_name_;
      bool build_db_name_specified_;
      string build_db_host_;
      bool build_db_host_specified_;
      uint16_t build_db_port_;
      bool build_db_port_specified_;
      size_t build_db_max_connections_;
      bool build_db_max_connections_specified_;
      size_t build_db_retry_;
      bool build_db_retry_specified_;
    };

    class page
    {
      public:
      page ();

      page (int& argc,
            char** argv,
            bool erase = false,
            ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
            ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      page (int start,
            int& argc,
            char** argv,
            bool erase = false,
            ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
            ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      page (int& argc,
            char** argv,
            int& end,
            bool erase = false,
            ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
            ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      page (int start,
            int& argc,
            char** argv,
            int& end,
            bool erase = false,
            ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
            ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      page (::brep::cli::scanner&,
            ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
            ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const web::xhtml::fragment&
      logo () const;

      web::xhtml::fragment&
      logo ();

      void
      logo (const web::xhtml::fragment&);

      bool
      logo_specified () const;

      void
      logo_specified (bool);

      const vector<page_menu>&
      menu () const;

      vector<page_menu>&
      menu ();

      void
      menu (const vector<page_menu>&);

      bool
      menu_specified () const;

      void
      menu_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_page_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      web::xhtml::fragment logo_;
      bool logo_specified_;
      vector<page_menu> menu_;
      bool menu_specified_;
    };

    class search
    {
      public:
      search ();

      search (int& argc,
              char** argv,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      search (int start,
              int& argc,
              char** argv,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      search (int& argc,
              char** argv,
              int& end,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      search (int start,
              int& argc,
              char** argv,
              int& end,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      search (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const uint16_t&
      search_results () const;

      uint16_t&
      search_results ();

      void
      search_results (const uint16_t&);

      bool
      search_results_specified () const;

      void
      search_results_specified (bool);

      const uint16_t&
      search_pages () const;

      uint16_t&
      search_pages ();

      void
      search_pages (const uint16_t&);

      bool
      search_pages_specified () const;

      void
      search_pages_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_search_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      uint16_t search_results_;
      bool search_results_specified_;
      uint16_t search_pages_;
      bool search_pages_specified_;
    };

    class package
    {
      public:
      package ();

      package (int& argc,
               char** argv,
               bool erase = false,
               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package (int start,
               int& argc,
               char** argv,
               bool erase = false,
               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package (int& argc,
               char** argv,
               int& end,
               bool erase = false,
               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package (int start,
               int& argc,
               char** argv,
               int& end,
               bool erase = false,
               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package (::brep::cli::scanner&,
               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const uint16_t&
      package_description () const;

      uint16_t&
      package_description ();

      void
      package_description (const uint16_t&);

      bool
      package_description_specified () const;

      void
      package_description_specified (bool);

      const uint16_t&
      package_changes () const;

      uint16_t&
      package_changes ();

      void
      package_changes (const uint16_t&);

      bool
      package_changes_specified () const;

      void
      package_changes_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_package_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      uint16_t package_description_;
      bool package_description_specified_;
      uint16_t package_changes_;
      bool package_changes_specified_;
    };

    class package_search: public ::brep::options::search,
      public ::brep::options::package_db,
      public ::brep::options::page,
      public ::brep::options::module
    {
      public:
      package_search ();

      package_search (int& argc,
                      char** argv,
                      bool erase = false,
                      ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                      ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_search (int start,
                      int& argc,
                      char** argv,
                      bool erase = false,
                      ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                      ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_search (int& argc,
                      char** argv,
                      int& end,
                      bool erase = false,
                      ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                      ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_search (int start,
                      int& argc,
                      char** argv,
                      int& end,
                      bool erase = false,
                      ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                      ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_search (::brep::cli::scanner&,
                      ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                      ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const string&
      search_title () const;

      string&
      search_title ();

      void
      search_title (const string&);

      bool
      search_title_specified () const;

      void
      search_title_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_package_search_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      string search_title_;
      bool search_title_specified_;
    };

    class package_details: public ::brep::options::package,
      public ::brep::options::search,
      public ::brep::options::package_db,
      public ::brep::options::page,
      public ::brep::options::module
    {
      public:
      package_details ();

      package_details (int& argc,
                       char** argv,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_details (int start,
                       int& argc,
                       char** argv,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_details (int& argc,
                       char** argv,
                       int& end,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_details (int start,
                       int& argc,
                       char** argv,
                       int& end,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_details (::brep::cli::scanner&,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_package_details_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
    };

    class package_version_details: public ::brep::options::package,
      public ::brep::options::package_db,
      public ::brep::options::build,
      public ::brep::options::build_db,
      public ::brep::options::page,
      public ::brep::options::module
    {
      public:
      package_version_details ();

      package_version_details (int& argc,
                               char** argv,
                               bool erase = false,
                               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_version_details (int start,
                               int& argc,
                               char** argv,
                               bool erase = false,
                               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_version_details (int& argc,
                               char** argv,
                               int& end,
                               bool erase = false,
                               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_version_details (int start,
                               int& argc,
                               char** argv,
                               int& end,
                               bool erase = false,
                               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_version_details (::brep::cli::scanner&,
                               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_package_version_details_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
    };

    class repository_details: public ::brep::options::package_db,
      public ::brep::options::page,
      public ::brep::options::module
    {
      public:
      repository_details ();

      repository_details (int& argc,
                          char** argv,
                          bool erase = false,
                          ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                          ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_details (int start,
                          int& argc,
                          char** argv,
                          bool erase = false,
                          ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                          ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_details (int& argc,
                          char** argv,
                          int& end,
                          bool erase = false,
                          ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                          ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_details (int start,
                          int& argc,
                          char** argv,
                          int& end,
                          bool erase = false,
                          ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                          ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_details (::brep::cli::scanner&,
                          ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                          ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_repository_details_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
    };

    class build_task: public ::brep::options::build,
      public ::brep::options::package_db,
      public ::brep::options::build_db,
      public ::brep::options::module
    {
      public:
      build_task ();

      build_task (int& argc,
                  char** argv,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_task (int start,
                  int& argc,
                  char** argv,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_task (int& argc,
                  char** argv,
                  int& end,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_task (int start,
                  int& argc,
                  char** argv,
                  int& end,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_task (::brep::cli::scanner&,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const size_t&
      build_task_request_max_size () const;

      size_t&
      build_task_request_max_size ();

      void
      build_task_request_max_size (const size_t&);

      bool
      build_task_request_max_size_specified () const;

      void
      build_task_request_max_size_specified (bool);

      const size_t&
      build_result_timeout () const;

      size_t&
      build_result_timeout ();

      void
      build_result_timeout (const size_t&);

      bool
      build_result_timeout_specified () const;

      void
      build_result_timeout_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_build_task_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      size_t build_task_request_max_size_;
      bool build_task_request_max_size_specified_;
      size_t build_result_timeout_;
      bool build_result_timeout_specified_;
    };

    class build_result: public ::brep::options::build,
      public ::brep::options::package_db,
      public ::brep::options::build_db,
      public ::brep::options::module
    {
      public:
      build_result ();

      build_result (int& argc,
                    char** argv,
                    bool erase = false,
                    ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                    ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_result (int start,
                    int& argc,
                    char** argv,
                    bool erase = false,
                    ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                    ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_result (int& argc,
                    char** argv,
                    int& end,
                    bool erase = false,
                    ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                    ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_result (int start,
                    int& argc,
                    char** argv,
                    int& end,
                    bool erase = false,
                    ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                    ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_result (::brep::cli::scanner&,
                    ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                    ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const size_t&
      build_result_request_max_size () const;

      size_t&
      build_result_request_max_size ();

      void
      build_result_request_max_size (const size_t&);

      bool
      build_result_request_max_size_specified () const;

      void
      build_result_request_max_size_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_build_result_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      size_t build_result_request_max_size_;
      bool build_result_request_max_size_specified_;
    };

    class build_log: public ::brep::options::build,
      public ::brep::options::package_db,
      public ::brep::options::build_db,
      public ::brep::options::module
    {
      public:
      build_log ();

      build_log (int& argc,
                 char** argv,
                 bool erase = false,
                 ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                 ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_log (int start,
                 int& argc,
                 char** argv,
                 bool erase = false,
                 ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                 ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_log (int& argc,
                 char** argv,
                 int& end,
                 bool erase = false,
                 ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                 ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_log (int start,
                 int& argc,
                 char** argv,
                 int& end,
                 bool erase = false,
                 ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                 ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_log (::brep::cli::scanner&,
                 ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                 ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_build_log_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
    };

    class build_force: public ::brep::options::build,
      public ::brep::options::package_db,
      public ::brep::options::build_db,
      public ::brep::options::module
    {
      public:
      build_force ();

      build_force (int& argc,
                   char** argv,
                   bool erase = false,
                   ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                   ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_force (int start,
                   int& argc,
                   char** argv,
                   bool erase = false,
                   ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                   ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_force (int& argc,
                   char** argv,
                   int& end,
                   bool erase = false,
                   ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                   ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_force (int start,
                   int& argc,
                   char** argv,
                   int& end,
                   bool erase = false,
                   ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                   ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_force (::brep::cli::scanner&,
                   ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                   ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_build_force_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
    };

    class builds: public ::brep::options::build,
      public ::brep::options::package_db,
      public ::brep::options::build_db,
      public ::brep::options::page,
      public ::brep::options::module
    {
      public:
      builds ();

      builds (int& argc,
              char** argv,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      builds (int start,
              int& argc,
              char** argv,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      builds (int& argc,
              char** argv,
              int& end,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      builds (int start,
              int& argc,
              char** argv,
              int& end,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      builds (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const uint16_t&
      build_configurations () const;

      uint16_t&
      build_configurations ();

      void
      build_configurations (const uint16_t&);

      bool
      build_configurations_specified () const;

      void
      build_configurations_specified (bool);

      const uint16_t&
      build_pages () const;

      uint16_t&
      build_pages ();

      void
      build_pages (const uint16_t&);

      bool
      build_pages_specified () const;

      void
      build_pages_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_builds_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      uint16_t build_configurations_;
      bool build_configurations_specified_;
      uint16_t build_pages_;
      bool build_pages_specified_;
    };

    class repository_root: public ::brep::options::module
    {
      public:
      repository_root ();

      repository_root (int& argc,
                       char** argv,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_root (int start,
                       int& argc,
                       char** argv,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_root (int& argc,
                       char** argv,
                       int& end,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_root (int start,
                       int& argc,
                       char** argv,
                       int& end,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_root (::brep::cli::scanner&,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_repository_root_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
    };
  }

  namespace params
  {
    class package_search
    {
      public:
      package_search ();

      package_search (int& argc,
                      char** argv,
                      bool erase = false,
                      ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                      ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_search (int start,
                      int& argc,
                      char** argv,
                      bool erase = false,
                      ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                      ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_search (int& argc,
                      char** argv,
                      int& end,
                      bool erase = false,
                      ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                      ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_search (int start,
                      int& argc,
                      char** argv,
                      int& end,
                      bool erase = false,
                      ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                      ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_search (::brep::cli::scanner&,
                      ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                      ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const uint16_t&
      page () const;

      uint16_t&
      page ();

      void
      page (const uint16_t&);

      bool
      page_specified () const;

      void
      page_specified (bool);

      const string&
      query () const;

      string&
      query ();

      void
      query (const string&);

      bool
      query_specified () const;

      void
      query_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_package_search_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      uint16_t page_;
      bool page_specified_;
      string query_;
      bool query_specified_;
    };

    class package_details
    {
      public:
      package_details ();

      package_details (int& argc,
                       char** argv,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_details (int start,
                       int& argc,
                       char** argv,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_details (int& argc,
                       char** argv,
                       int& end,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_details (int start,
                       int& argc,
                       char** argv,
                       int& end,
                       bool erase = false,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_details (::brep::cli::scanner&,
                       ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                       ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const uint16_t&
      page () const;

      uint16_t&
      page ();

      void
      page (const uint16_t&);

      bool
      page_specified () const;

      void
      page_specified (bool);

      const string&
      query () const;

      string&
      query ();

      void
      query (const string&);

      bool
      query_specified () const;

      void
      query_specified (bool);

      const page_form&
      form () const;

      page_form&
      form ();

      void
      form (const page_form&);

      bool
      form_specified () const;

      void
      form_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_package_details_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      uint16_t page_;
      bool page_specified_;
      string query_;
      bool query_specified_;
      page_form form_;
      bool form_specified_;
    };

    class package_version_details
    {
      public:
      package_version_details ();

      package_version_details (int& argc,
                               char** argv,
                               bool erase = false,
                               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_version_details (int start,
                               int& argc,
                               char** argv,
                               bool erase = false,
                               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_version_details (int& argc,
                               char** argv,
                               int& end,
                               bool erase = false,
                               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_version_details (int start,
                               int& argc,
                               char** argv,
                               int& end,
                               bool erase = false,
                               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      package_version_details (::brep::cli::scanner&,
                               ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                               ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const page_form&
      form () const;

      page_form&
      form ();

      void
      form (const page_form&);

      bool
      form_specified () const;

      void
      form_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_package_version_details_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      page_form form_;
      bool form_specified_;
    };

    class repository_details
    {
      public:
      repository_details ();

      repository_details (int& argc,
                          char** argv,
                          bool erase = false,
                          ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                          ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_details (int start,
                          int& argc,
                          char** argv,
                          bool erase = false,
                          ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                          ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_details (int& argc,
                          char** argv,
                          int& end,
                          bool erase = false,
                          ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                          ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_details (int start,
                          int& argc,
                          char** argv,
                          int& end,
                          bool erase = false,
                          ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                          ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      repository_details (::brep::cli::scanner&,
                          ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                          ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_repository_details_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
    };

    class build_task
    {
      public:
      build_task ();

      build_task (int& argc,
                  char** argv,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_task (int start,
                  int& argc,
                  char** argv,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_task (int& argc,
                  char** argv,
                  int& end,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_task (int start,
                  int& argc,
                  char** argv,
                  int& end,
                  bool erase = false,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_task (::brep::cli::scanner&,
                  ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                  ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const vector<string>&
      repository () const;

      vector<string>&
      repository ();

      void
      repository (const vector<string>&);

      bool
      repository_specified () const;

      void
      repository_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_build_task_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      vector<string> repository_;
      bool repository_specified_;
    };

    class build_result
    {
      public:
      build_result ();

      build_result (int& argc,
                    char** argv,
                    bool erase = false,
                    ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                    ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_result (int start,
                    int& argc,
                    char** argv,
                    bool erase = false,
                    ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                    ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_result (int& argc,
                    char** argv,
                    int& end,
                    bool erase = false,
                    ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                    ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_result (int start,
                    int& argc,
                    char** argv,
                    int& end,
                    bool erase = false,
                    ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                    ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_result (::brep::cli::scanner&,
                    ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                    ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_build_result_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
    };

    class build_log
    {
      public:
      build_log ();

      build_log (int& argc,
                 char** argv,
                 bool erase = false,
                 ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                 ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_log (int start,
                 int& argc,
                 char** argv,
                 bool erase = false,
                 ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                 ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_log (int& argc,
                 char** argv,
                 int& end,
                 bool erase = false,
                 ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                 ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_log (int start,
                 int& argc,
                 char** argv,
                 int& end,
                 bool erase = false,
                 ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                 ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_log (::brep::cli::scanner&,
                 ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                 ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_build_log_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
    };

    class build_force
    {
      public:
      build_force ();

      build_force (int& argc,
                   char** argv,
                   bool erase = false,
                   ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                   ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_force (int start,
                   int& argc,
                   char** argv,
                   bool erase = false,
                   ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                   ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_force (int& argc,
                   char** argv,
                   int& end,
                   bool erase = false,
                   ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                   ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_force (int start,
                   int& argc,
                   char** argv,
                   int& end,
                   bool erase = false,
                   ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                   ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      build_force (::brep::cli::scanner&,
                   ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
                   ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const string&
      package () const;

      string&
      package ();

      void
      package (const string&);

      bool
      package_specified () const;

      void
      package_specified (bool);

      const string&
      version () const;

      string&
      version ();

      void
      version (const string&);

      bool
      version_specified () const;

      void
      version_specified (bool);

      const string&
      configuration () const;

      string&
      configuration ();

      void
      configuration (const string&);

      bool
      configuration_specified () const;

      void
      configuration_specified (bool);

      const string&
      toolchain_version () const;

      string&
      toolchain_version ();

      void
      toolchain_version (const string&);

      bool
      toolchain_version_specified () const;

      void
      toolchain_version_specified (bool);

      const string&
      reason () const;

      string&
      reason ();

      void
      reason (const string&);

      bool
      reason_specified () const;

      void
      reason_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_build_force_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      string package_;
      bool package_specified_;
      string version_;
      bool version_specified_;
      string configuration_;
      bool configuration_specified_;
      string toolchain_version_;
      bool toolchain_version_specified_;
      string reason_;
      bool reason_specified_;
    };

    class builds
    {
      public:
      builds ();

      builds (int& argc,
              char** argv,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      builds (int start,
              int& argc,
              char** argv,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      builds (int& argc,
              char** argv,
              int& end,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      builds (int start,
              int& argc,
              char** argv,
              int& end,
              bool erase = false,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      builds (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option = ::brep::cli::unknown_mode::fail,
              ::brep::cli::unknown_mode argument = ::brep::cli::unknown_mode::stop);

      // Option accessors and modifiers.
      //
      const uint16_t&
      page () const;

      uint16_t&
      page ();

      void
      page (const uint16_t&);

      bool
      page_specified () const;

      void
      page_specified (bool);

      const string&
      name () const;

      string&
      name ();

      void
      name (const string&);

      bool
      name_specified () const;

      void
      name_specified (bool);

      const string&
      version () const;

      string&
      version ();

      void
      version (const string&);

      bool
      version_specified () const;

      void
      version_specified (bool);

      const string&
      toolchain () const;

      string&
      toolchain ();

      void
      toolchain (const string&);

      bool
      toolchain_specified () const;

      void
      toolchain_specified (bool);

      const string&
      configuration () const;

      string&
      configuration ();

      void
      configuration (const string&);

      bool
      configuration_specified () const;

      void
      configuration_specified (bool);

      const string&
      machine () const;

      string&
      machine ();

      void
      machine (const string&);

      bool
      machine_specified () const;

      void
      machine_specified (bool);

      const string&
      target () const;

      string&
      target ();

      void
      target (const string&);

      bool
      target_specified () const;

      void
      target_specified (bool);

      const string&
      result () const;

      string&
      result ();

      void
      result (const string&);

      bool
      result_specified () const;

      void
      result_specified (bool);

      // Option description.
      //
      static const ::brep::cli::options&
      description ();

      // Implementation details.
      //
      protected:
      friend struct _cli_builds_desc_type;

      static void
      fill (::brep::cli::options&);

      bool
      _parse (const char*, ::brep::cli::scanner&);

      private:
      bool
      _parse (::brep::cli::scanner&,
              ::brep::cli::unknown_mode option,
              ::brep::cli::unknown_mode argument);

      public:
      uint16_t page_;
      bool page_specified_;
      string name_;
      bool name_specified_;
      string version_;
      bool version_specified_;
      string toolchain_;
      bool toolchain_specified_;
      string configuration_;
      bool configuration_specified_;
      string machine_;
      bool machine_specified_;
      string target_;
      bool target_specified_;
      string result_;
      bool result_specified_;
    };
  }
}

#include <mod/options.ixx>

// Begin epilogue.
//
//
// End epilogue.

#endif // MOD_OPTIONS_HXX
